/**************************************************************************
*   Copyright (C) 2009 by Ian Reinhart Geiser                             *
*   geiseri@kde.org                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "launcherbutton.h"
#include "launcher.h"

#include <KDE/KPopupFrame>
#include <KDE/KIcon>
#include <KDE/KLocale>
#include <KDE/KApplication>

#include <QDesktopWidget>

LauncherButton::LauncherButton( QWidget *parent ) : KPushButton(parent)
{
    setObjectName("LauncherButton");
    setIcon(KIcon("start-here-kde"));
    setText(i18n("Computer"));

    m_launcherMenu = new KPopupFrame(this);
    m_launcherMenu->setObjectName("LauncherPopup");

    m_launcher = new Launcher(m_launcherMenu);

    m_launcherMenu->setMainWidget( m_launcher );

    connect( this, SIGNAL(clicked()), this, SLOT(showLauncher()));
    connect( m_launcher, SIGNAL(popupDone(int)), m_launcherMenu, SLOT(close(int)));
}

LauncherButton::~LauncherButton()
{

}

void LauncherButton::showLauncher()
{
    m_launcher->adjustSize();
    m_launcherMenu->adjustSize();
    m_launcherMenu->exec( QApplication::desktop()->screenGeometry(this).x() + x(), height() + y() );
}

