#ifndef PAGER_H
#define PAGER_H
/**************************************************************************
*   Copyright (C) 2009 by Ian Reinhart Geiser                             *
*   geiseri@kde.org                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <QFrame>

class QButtonGroup;
class QHBoxLayout;
class QAbstractButton;

class Pager : public QFrame
{
    Q_OBJECT
public:
    Pager( QWidget *parent = 0);

private slots:
    void slotCurrentDesktopChanged (int desktop);
    void slotDesktopNamesChanged ();
    void slotNumberOfDesktopsChanged (int num);
    void slotSetCurrentDesktop( QAbstractButton *button );

private:
    QButtonGroup *m_desktops;
    QHBoxLayout *m_pagerLayout;
};

#endif // PAGER_H
