/**************************************************************************
*   Copyright (C) 2009 by Ian Reinhart Geiser                             *
*   geiseri@kde.org                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef TASKITEMBUTTON_H
#define TASKITEMBUTTON_H

#include <QAbstractButton>
#include <QIcon>

#include <KDE/KPushButton>

#include <taskmanager/groupmanager.h>

class TaskItemButton : public KPushButton
{
    Q_OBJECT
public:
    TaskItemButton(TaskManager::AbstractGroupableItem *ptr, TaskManager::GroupManager *mgr, QWidget *parent);

    void setActive( bool act );
    QSize sizeHint() const;
    QSize minimumSizeHint() const;

public slots:
    void updateTask();

protected:
    virtual void mousePressEvent ( QMouseEvent * event );
    virtual void resizeEvent( QResizeEvent *event );
private:
    QString squeezeTextToButton( const QString &text, int iconSz );
    TaskManager::AbstractGroupableItem *m_ptr;
    TaskManager::GroupManager *m_mgr;
};

#endif // TASKITEMBUTTON_H
