/**
 *  Copyright (C) 2005 Benjamin C Meyer (ben at meyerhome dot net)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Steet, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include <QString>
#include <QTime>

#define LOOP 99999999

/**
 * TEST: at vs []  Although at() should be faster, lets see what the compiler does... 
 */
int main( int argc, char *argv[] ) {
    {
    QString list;
    for(long i=0; i < LOOP; i++){
	list[(uint)i] = QChar('x');
    }
    QTime t;
    t.start();
    for (long i = 0; i < list.size(); ++i)
        list.at(i);
    qDebug("QString.at():  %d", t.elapsed());
    }
    
    {
    QString list;
    for(long i=0; i < LOOP; i++){
	list[(uint)i] = QChar('x');
    }
    QTime t;
    t.start();
    for (long i = 0; i < list.size(); ++i)
        list[(uint)i];
    qDebug("QString[]:  %d", t.elapsed());
    }
   
    qDebug("See ../stringlisttraverse/ for QList");
    return 0;
}

