/**
 *  Copyright (C) 2004-2005 Benjamin C Meyer (ben at meyerhome dot net)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

/**
 * TEST: QString.sprintf() V.S. QString.arg()
 * 
 */

#include <sys/time.h>
#include <qstring.h>

#define LOOP 10000

/**
 * Read in paramaters and output a maze line by line.
 */
int main( int /*argc*/, char /* *argv[]*/ ) {
	struct timeval tv1;
	struct timeval tv2;
		
	gettimeofday(&tv1, NULL);
  	for(int i=0; i< LOOP; i++)
		QString("%1").arg((int)6, 2, 10, QLatin1Char('0'));

	gettimeofday(&tv2, NULL);
	qDebug("arg()     post:  %d", (tv2.tv_usec-tv1.tv_usec));


	gettimeofday(&tv1, NULL);
  	for(int i=0; i< LOOP; i++){
		QString a;
		a.sprintf("%02d", 6);
	}
	gettimeofday(&tv2, NULL);
	
	qDebug("sprintf() post:  %d", (tv2.tv_usec-tv1.tv_usec));
	return 0;
}

