/*
    This file is part of KDE.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef INSTALLER_H
#define INSTALLER_H

#include <kurl.h>

#include <qstring.h>
#include <qobject.h>

class QWidget;
class KProcess;
class Engine;

namespace KNS {
class Entry;
}

class Installer : public QObject
{
    Q_OBJECT
  public:
    Installer( Engine *, QWidget *parent );

  public slots:
    void install( KNS::Entry * ); 

  signals:
    void installationFailed( const QString & );
    void installationFinished();

  protected:
    virtual void doInstall( KNS::Entry * ) = 0;

    void finishInstallation();

    Engine *engine() const { return mEngine; }
    QWidget *widget() const { return mWidget; }

  protected slots:
    void slotRestart();

  private:
    Engine *mEngine;
    QWidget *mWidget;

    QString mAppname;
};

#endif
