/*
    This file is part of KDE.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef INSTALLERRPM_H
#define INSTALLERRPM_H

#include "installer.h"

class KProcess;

namespace KNS {
class Entry;
}

class InstallerRpm : public Installer
{
    Q_OBJECT
  public:
    InstallerRpm( Engine *e, QWidget * );

  protected:
    void doInstall( KNS::Entry * ); 

  protected slots:
    void slotDownloadFinished( const QString &path );
    void slotDownloadFailed( const QString &msg );

    void slotReceivedStdout(KProcess *proc, char *buffer, int buflen);
    void slotReceivedStderr(KProcess *proc, char *buffer, int buflen);

  protected slots:
    void slotProcessExited( KProcess * );

  private:
    QString mStdout;
    QString mStderr;
};

#endif
