/* This file is part of the KDE project

   Copyright (C) 2005 Ramakrishna R <coolrama@gmail.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; version 2
   of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Steet, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include "klbplugin.h"
#include "lbapi.h"

#include <kapplication.h>
#include <kstandarddirs.h>
#include <kmimetype.h>
#include <kdebug.h>
#include <kaction.h>
#include <kinstance.h>
#include <klocale.h>
#include <konq_popupmenu.h>
#include <kpopupmenu.h>
#include <kgenericfactory.h>
#include <kurl.h>
#include <kio/netaccess.h>
#include <klibloader.h>

#include <qdir.h>
#include <qsignalmapper.h>
#include <qobject.h>

#include <exception>

typedef KGenericFactory<LabelMenu, KonqPopupMenu> LabelMenuFactory;
K_EXPORT_COMPONENT_FACTORY( libklbplugin, LabelMenuFactory("klbplugin")) 
LabelMenu::LabelMenu( KonqPopupMenu * popupmenu, const char *name, const QStringList& /* list */ )
                : KonqPopupMenuPlugin( popupmenu, name)
{
	//	m_conf = new KConfig( "labelBrowserrc" );
	// 	m_conf->setGroup( "labelBrowserKonqPlugin" );
    	// 
	// 	if ( !m_conf->readBoolEntry( "KonquerorIntegration", true ) )
	//        return;
	
	kdDebug() << "Entered labelMenu constructor"<<endl;

	KGlobal::locale()->insertCatalogue("klb_konqplugin");
	
	popup = popupmenu;

	// get all labels
//	QStringList allLabels ;
	KLB::LabelManager manager;

	try
	{
		manager.getAllLabels(labelsList);
	}
	catch (exception& ex)
	{
		kdError() << ex.what() << endl;
	}

 //	kdDebug()<<allLabels<<endl;	
	kdDebug()<< "listing first few values of labelsList "<<endl;	
//	kdDebug()<<*labelsList->at(0) << *labelsList->at(1)<<endl;
  /*     
        QStringList  list ;
	list = list.split(",", *labelsList);

        QString temp;
	//labelsList = new QStringList();
        for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it )
       {
            temp = *it;
            temp = temp.mid(1,temp.length()-2);
            labelsList->append(temp) ;
       }
*/
	KActionMenu *actionMenu = new KActionMenu( i18n( "labelsmenu" ),0, actionCollection(),"labels_menu");

	QSignalMapper* m_addToMapper = new QSignalMapper( this, "addToMapper" );

	KAction *action;
	unsigned int counter =0;

	for(QStringList::Iterator it = labelsList.begin(); it!=labelsList.end(); ++it)
	{
		action = new KAction( i18n( *it ),0, m_addToMapper,SLOT( map()), actionCollection() );
		actionMenu->insert( action );
		m_addToMapper->setMapping( action, counter );
		counter++;		
	
	}
      
/*

        KAction * action = new KAction( i18n( "ApplyLabel" ),0, m_addToMapper,SLOT( map()), actionCollection() );

	actionMenu->insert( action );
	m_addToMapper->setMapping( action, 1 );
       
	action = new KAction( i18n( "ApplyLabel2" ), 0, m_addToMapper,
                                SLOT( map() ), actionCollection() );
        actionMenu->insert( action );
	m_addToMapper->setMapping( action, 2 );
*/

	addAction(actionMenu);
        connect( m_addToMapper, SIGNAL( mapped( int ) ), SLOT( slotklb( int ) ) );


/*
       for ( mit = m_extensionList.begin(); mit != m_extensionList.end(); ++mit )
            if ( (*uit).endsWith(*mit) )
            {
                action = new KAction( *uit, 0, m_addToMapper,
                                      SLOT( map() ), actionCollection() );
                m_addToMenu->insert( action );
                m_addToMapper->setMapping( action, counter );
                archive.setPath( *uit );
                m_archiveList << archive;
                counter++;
                break;
            }
    }
    connect( m_addToMapper, SIGNAL( mapped( int ) ), SLOT( slotAddTo( int ) ) );


*/
/*
 
	action = new KAction( i18n( "ApplyLabel2" ), 0, this,
                                SLOT( slotklb("hello") ), actionCollection() );
        actionMenu->insert( action );


	addAction(actionMenu);

*/

//	KAction * my_action = new KAction( "labels", 0, this, SLOT( slotklb( ) ), actionCollection( ), "Do some stuff"  );

//	addAction( my_action );
//my_action = new KAction( "labels2", 0, this, SLOT( slotklb( ) ), actionCollection( ), "Do some stuff"  );
	
//	addAction( my_action );
	addSeparator();
	//connect( popup, SIGNAL(aboutToShow() ), this, SLOT(slotPrepareMenu( ) ) );
	
}

void LabelMenu::slotklb(int ss)
{
	kdDebug() << "Entered Slotklb..." << endl;
	kdDebug() << "In Slotklb parameter ss = ." << ss << endl;


	QStringList args;
	
	KFileItemList list = popup->fileItemList();
        KFileItem* it = list.first();
	
	kdDebug() << it->url().prettyURL()<<endl;	
//	args<<"rama";
	args << "-n";
	args<< *labelsList.at(ss);
	args << "-p";
	args<<it->url().prettyURL();
 

	kdDebug() << "first file url " << it->url().prettyURL()<< endl;
	kapp->kdeinitExec( "applylabel", args );
}



#include "klbplugin.moc"
