/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef MERGERWIDGET_H
#define MERGERWIDGET_H

#include "ui_mergerwidget.h"

#include <QtGui/QWidget>
#include <QtGui/QListView>

class OrgKdeNepomukServicesNepomukbackupsyncMergerInterface;

namespace Nepomuk {

    class MergerModel;

    class MergerWidget : public QWidget, public Ui::MergerWidget
    {
        Q_OBJECT
    public:
        MergerWidget( QWidget* parent = 0);
        virtual ~MergerWidget();

    private slots:
        void ignoreClicked();
        void ignoreAllClicked();
        void resolveClicked();
        
    private:
        MergerModel * m_model;

        typedef OrgKdeNepomukServicesNepomukbackupsyncMergerInterface Merger;
        Merger * m_merger;
    };

}

#endif // MERGERWIDGET_H
