/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef BACKUPSTORAGE_H
#define BACKUPSTORAGE_H

#include <QtCore/QList>
#include <QtCore/QUrl>
#include <QtCore/QDateTime>


namespace Nepomuk {

    class SyncFile;
    class ChangeLog;
    
    class BackupStorage
    {
    public:
        BackupStorage( const QString & url = QString() );
        virtual ~BackupStorage();

        void create();
        void add( const ChangeLog & log );
        void add( const QUrl & syncFileUrl );

        bool exists() const;

        QList<SyncFile> syncFiles() const;
        QList<QDateTime> syncFileDates() const;

        SyncFile syncFile( const QDateTime & dateTime ) const;

        QDateTime lastBackup() const;

        void remove();

    private:
        QString m_url;
    };

}

#endif // BACKUPSTORAGE_H
