/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mergerecord.h"

#include <Soprano/Model>
#include <Nepomuk/ResourceManager>

Nepomuk::MergeRecord::MergeRecord(const Soprano::Statement& o, const Soprano::Statement& n)
    : oldSt( o ),
      newSt( n )
{
}


Nepomuk::MergeRecord::MergeRecord(const QString& string)
{

}


QString Nepomuk::MergeRecord::toString() const
{
    return QString();
}


void Nepomuk::MergeRecord::revert() const
{
    Soprano::Model * model = Nepomuk::ResourceManager::instance()->mainModel();

    model->removeStatement( newSt );
    model->addStatement( oldSt );
}

