/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SYNCFILEIDENTIFIER_H
#define SYNCFILEIDENTIFIER_H

#include <nepomuk/resourceidentifier.h>
#include "changelog.h"
#include "identificationset.h"
#include "syncfile.h"

namespace Nepomuk {
    
    class SyncFileIdentifier : public Sync::ResourceIdentifier
    {
    public:
        SyncFileIdentifier( const SyncFile & sf );
        virtual ~SyncFileIdentifier();
        
        virtual void identifyAll();
        int id();
        
        ChangeLog convertedChangeLog();
        void load();

    protected:
        virtual Resource additionalIdentification(const KUrl& uri);
        
    private:
        ChangeLog m_changeLog;
        IdentificationSet m_identificationSet;
        
        static int NextId;
        int m_id;

        Resource createNewResource(const Nepomuk::Sync::SimpleResource& simpleRes) const;
        
    };
}

#endif // SYNCFILEIDENTIFIER_H
