/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SYNCMANAGER_H
#define SYNCMANAGER_H

#include <QObject>
#include <QUrl>
#include <QDateTime>

namespace Nepomuk {

    class Identifier;
    class Merger;

    class SyncFile;
    
    class SyncManager : public QObject
    {
        Q_OBJECT
        Q_CLASSINFO("D-Bus Interface", "org.kde.nepomuk.services.nepomukbackupsync.SyncManager")
        
    public :
        SyncManager(Identifier * ident, Merger * merger, QObject * parent = 0);
        virtual ~SyncManager();

    public slots:
        int sync( const QString & url );
        int sync( const QUrl & url );

        void createSyncFile( const QString & url, const QString& startTime );
        void createSyncFile( const QUrl& outputUrl, const QList<QString> & nieUrls );
        void createSyncFile( const QUrl& outputUrl, QSet<QUrl>& nepomukUris, const QDateTime & min );
        void createFirstSyncFile( const QUrl& outputUrl ) const;

    private :
        Identifier * m_identifier;
        Merger * m_merger;
    };
}

#endif // SYNCMANAGER_H
