/* This file is part of the Nepomuk Project
   Copyright (c) 2009 Alessandro Sivieri <alessandro.sivieri@gmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include "contactswidget.h"

ContactsWidget::ContactsWidget(const QStringList& items, QWidget* parent): QWidget(parent)
{
    setupUi(this);
    m_contactsView->setSelectionMode(QAbstractItemView::MultiSelection);
    m_model = new QStringListModel(items, m_contactsView);
    m_contactsView->setModel(m_model);
}

ContactsWidget::~ContactsWidget()
{
}
    
QStringList ContactsWidget::getContacts()
{
    QStringList result;
    QItemSelectionModel* selModel = m_contactsView->selectionModel();
    QModelIndexList list = selModel->selectedRows();
    foreach (QModelIndex idx, list) {
        result << m_model->data(idx, Qt::DisplayRole).toString();
    }
    
    return result;
}

bool ContactsWidget::getUpdatesRequest()
{
    return m_updateBox->isChecked();
}
