/*
 * Copyright (c) 2010 Ivan Cukic <ivan.cukic(at)kde.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License version 2 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef ActivitiesKio_H
#define ActivitiesKio_H

#include <KIO/ForwardingSlaveBase>

/**
 *   This class implements Activities kioslave
 */
class Activities: public KIO::ForwardingSlaveBase {
public:
    Activities(const QByteArray & pool, const QByteArray & app);
    ~Activities();

    void get(const KUrl & url);
    void stat(const KUrl & url);
    void listDir(const KUrl & url);
    bool rewriteUrl(const KUrl & url, KUrl & newURL);
    void mimetype(const KUrl & url);

private:
    class Private;
    Private * const d;
};

#endif

