/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef NEPOMUK_METADATASHARING_SERVICE_H
#define NEPOMUK_METADATASHARING_SERVICE_H

#include <Nepomuk/Service>

namespace Nepomuk {

    class MetadataSharing : public Service
    {
        Q_OBJECT
    public:
        MetadataSharing( QObject * parent = 0, const QList<QVariant>& args = QList<QVariant>() );
        ~MetadataSharing();

    public slots:
        //
        // Resource Sharing
        //
        void metadataUriReceived( const QString & fromId, const QString & uri );
        void metadataReceived( const QString & fromId, const QString & uri, const QString & serializedMetadata );
        void metadataRequest( const QString & fromId, const QString & uri );

        //
        // Remote Queries
        //
        void executeQuery( const QString & toId, const QString & serializedQuery );
        void queryResultsReceived( const QString & fromId, const QString & serializedResults );
        
    signals:
        //
        // Resource Sharing
        //
        void publishMetadata( const QString & toId, const QString & uri, const QString & serializedMetadata );
        void requestMetadata( const QString & toId, const QString & uri );

        //
        // Remote Queries
        //
        void publishQueryResults( const QString & toId, const QString & serializedResults );
        
    private:
      
    };

}

#endif // NEPOMUK_METADATASHARING_SERVICE_H
