/*
 *
 * $Id: sourceheader 511311 2006-02-19 14:51:05Z trueg $
 *
 * This file is part of the Nepomuk KDE project.
 * Copyright (C) 2006 Sebastian Trueg <trueg@kde.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#ifndef _STATEMENT_LIST_MODEL_H_
#define _STATEMENT_LIST_MODEL_H_

#include <QtCore/QAbstractItemModel>
#include <QtCore/QModelIndex>
#include <QtCore/QVariant>
#include <QtCore/QList>

#include <soprano/statement.h>

namespace Nepomuk {
    class StatementListModel : public QAbstractItemModel
    {
        Q_OBJECT

    public:
        StatementListModel( QObject* parent = 0 );
        ~StatementListModel();

        QList<Soprano::Statement> statements() const;

        void setStatements( const QList<Soprano::Statement>& statements );
        void addStatements( const QList<Soprano::Statement>& statements );
        void addStatement( const Soprano::Statement& statement );

        void clear();

        int columnCount( const QModelIndex& parent = QModelIndex() ) const;
        QVariant headerData( int section, Qt::Orientation orientation, int role = Qt::DisplayRole ) const;
        QVariant data( const QModelIndex& index, int role = Qt::DisplayRole ) const;
        QModelIndex index( int row, int column, const QModelIndex& parent = QModelIndex() ) const;
        QModelIndex parent( const QModelIndex& index ) const;
        int rowCount( const QModelIndex& parent = QModelIndex() ) const;

    private:
        class Private;
        Private* const d;
    };
}

#endif
