/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GENERICRESOURCEEDITPLUGIN_H
#define GENERICRESOURCEEDITPLUGIN_H


#include "abstractresourceeditplugin.h"

#include <QList>
#include <QVariant>

#include "nepomuksearchgui_export.h"


namespace Nepomuk
{


    /**
     * A widget which provides displaying and editing of one Nepomuk::Resource
     * It uses a PropertyEditPlugin for each property of the resource.
     *
     * It has two buttons (Edit/Save and Cancel). Initially only Edit is enabled.
     * When Edit is clicked, the Editing mode is activated and the Edit button is changed to Save,
     * while Cancel is enabled.
     * If Save or Cancel is clicked, the Save button is changed to Edit, and Cancel is disabled,
     * and the new values of the properties are saved or discarded, respectively.
     *
     * @author Oszkar Ambrus aoszkar@gmail.com
     */

    class NEPOMUKSEARCHGUI_EXPORT GenericResourceEditPlugin : public AbstractResourceEditPlugin
    {
        Q_OBJECT

    public:
        /**
         * Creates a new GenericResourceEditPlugin
         */
        GenericResourceEditPlugin( QWidget *parent = 0);
        ~GenericResourceEditPlugin();

    private:
        void initGui();
        class Private;
        Private * const d;
    };

}

#endif // GENERICRESOURCEEDITPLUGIN_H
