/*  This file is part of the KDE semantic clipboard
    Copyright (C) 2008 Tobias Wolf <twolf@access.unizh.ch>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef _XMLRPC_H_
#define _XMLRPC_H_

#include <QtCore/QObject>
#include <QtCore/QList>

class QEventLoop;
class QString;
class QUrl;
class QVariant;

namespace KXmlRpc
{
    class Client;
}

class XmlRpc : public QObject
{
    Q_OBJECT

public:
    XmlRpc( const QUrl& service, QObject* parent = 0 );
    void findMapping( const QUrl& source, const QUrl& target, const QVariant& id );

private slots:
    void gotData( const QList< QVariant >& result, const QVariant& id );
    void gotError( int errorCode, const QString& errorString, const QVariant& id );

private:
    QEventLoop*      loop;
    KXmlRpc::Client* client;
};

#endif
