/*  This file is part of the KDE semantic clipboard
    Copyright (C) 2008 Tobias Wolf <twolf@access.unizh.ch>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "xmlrpc.h"

#include <QtCore/QUrl>

#include <KAboutData>
#include <KApplication>
#include <KCmdLineArgs>

int main( int argc, char* argv[] )
{
    KAboutData aboutData( QByteArray( "XmlRpc" ), QByteArray(), KLocalizedString(), QByteArray() );
    KCmdLineArgs::init( argc, argv, &aboutData );
    KApplication app;

    const QUrl foaf( "http://xmlns.com/foaf/0.1/" );
    const QUrl vcardold( "http://www.w3.org/2001/vcard-rdf/3.0#" );
    const QUrl vcard( "http://www.w3.org/2006/vcard/ns#" );
    const QUrl swrc( "http://swrc.ontoware.org/ontology#" );
    const QUrl invalid( "http://example.org/invalid/" );

    XmlRpc xmlrpc( QUrl( "http://seal.ifi.uzh.ch/mappinglib" ) );
    xmlrpc.findMapping( foaf, vcard, QVariant( "foaf2vcard" ) );
    xmlrpc.findMapping( vcard, foaf, QVariant( "vcard2foaf" ) );
    xmlrpc.findMapping( swrc, vcard, QVariant( "swrc2vcard" ) );
    xmlrpc.findMapping( vcard, swrc, QVariant( "vcard2swrc" ) );

    return 0;
}
