/*
 *   Copyright (C) 2007 Ivan Cukic <ivan.cukic+kde@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser/Library General Public License version 2,
 *   or (at your option) any later version, as published by the Free
 *   Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser/Library General Public License for more details
 *
 *   You should have received a copy of the GNU Lesser/Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef EMBEDDED_TITLEBAR_H_
#define EMBEDDED_TITLEBAR_H_

#include <QSignalMapper>
#include <QGraphicsSceneMouseEvent>
#include <QMap>
#include <KIcon>

#include <Plasma/Applet>
#include <Plasma/Svg>

#include <taskmanager/taskmanager.h>

class KDialog;
class QSizeF;

using TaskManager::StartupPtr;
using TaskManager::TaskPtr;
using TaskManager::Task;

class EmbeddedTitlebarApplet : public Plasma::Applet {
    Q_OBJECT
public:
    EmbeddedTitlebarApplet(QObject * parent, const QVariantList & args);
    ~EmbeddedTitlebarApplet();

    void init();
    void paintInterface(QPainter * painter, const QStyleOptionGraphicsItem * option, const QRect & contentsRect);

    void mousePressEvent(QGraphicsSceneMouseEvent * event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent * event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent * event);

protected Q_SLOTS:
    void taskAdded(TaskPtr task);
    void taskRemoved(TaskPtr task);
    void taskActivated();

protected:
    void constraintsEvent(Plasma::Constraints constraints);

private:
    QString m_title;

};

K_EXPORT_PLASMA_APPLET(embeddedTitlebar, EmbeddedTitlebarApplet)

#endif // EMBEDDED_TITLEBAR_H_
