/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#ifndef PHOTO_SAVE_BIN_H
#define PHOTO_SAVE_BIN_H
#include <QImage>
#include "libqtgstreamer/qgstbin.h"

typedef struct _GstBuffer GstBuffer;

class PhotoSaveBin;
typedef QSharedPointer<PhotoSaveBin> PhotoSaveBinPtr;

class PhotoSaveBinPrivate;
class PhotoSaveBin : public QtGstreamer::QGstBin
{
    Q_OBJECT
    Q_DISABLE_COPY(PhotoSaveBin)
public:
    friend class PhotoSaveBinPrivate;
    
    static PhotoSaveBinPtr createPhotoSaveBin(const QSize &photoSize);
    virtual ~PhotoSaveBin();

    QSize &photoSize() const;
    void updatePhotoSize(const QSize &photoSize);
    void takePhoto();

signals:
    void photoTaken(QImage *image);

protected:
    PhotoSaveBin();

private:
    PhotoSaveBinPrivate *const d;
};

#endif