/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#ifndef PREVIEWWIDGET_H
#define PREVIEWWIDGET_H

#include <QImage>
#include <QGraphicsWidget>

class QGraphicsSceneResizeEvent;
namespace Plasma {
    class Svg;
}
class InfoWidget;
class VideoProxyWidget;

class PreviewWidget : public QGraphicsWidget
{
    Q_OBJECT
public:
    PreviewWidget(QGraphicsItem *parent = 0, Qt::WindowFlags wFlags = 0);
    ~PreviewWidget();

    void startCountDownTimer(int counter);
    InfoWidget * infoWidget() { return mInfoWidget; }
    VideoProxyWidget *videoWidget() { return mVideoWidget; }

private Q_SLOTS:
    void slotCountDownFinished();
signals:
    void countDownFinished();

protected:
    void resizeEvent(QGraphicsSceneResizeEvent *event);
private:
    VideoProxyWidget *mVideoWidget;
    int mInfoAreaHeight;
    QRect mInfoAreaMargin;
    InfoWidget * mInfoWidget;
    Plasma::Svg *mSvg;
};

#endif