/***************************************************************************
 *   Copyright (C) 2010 Reza Fatahilah Shah <rshah0385@kireihana.com>      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KNEWSTUFF_PLASMOID_H
#define KNEWSTUFF_PLASMOID_H
#include <QString>
#include <knewstuff3/entry.h>
#include <Plasma/Applet>

namespace Plasma {
    class IconWidget;
}

/*namespace KNS3 {
    class DownloadManager;
}*/
class QTimer;

class KNewStuffPlasmoid : public Plasma::Applet
{
    Q_OBJECT
    public:
        KNewStuffPlasmoid(QObject *parent, const QVariantList &args);
        ~KNewStuffPlasmoid();
        
        void init();
        //void constraintsEvent(Plasma::Constraints constraints);
        
        void createUi();
        
    private slots:
        void slotUpdateTimer();
        void slotOpenKNewstuffDialog();
        //void slotUpdatesAvailable(const KNS3::Entry::List& updates);
        
    private:
        void newCheckingSession(QString &fileName);
        void sendNotification(QString &message);
        
    private:
        QTimer *mUpdateTimer;
        int mUpdateInterval;
        
        Plasma::IconWidget *mKNewstuffIcon;
        /*KNS3::DownloadManager* mNewStuffManager;
        KNS3::Entry::List mUpdateableEntries;*/
};
K_EXPORT_PLASMA_APPLET(knewstuff_plasmoid, KNewStuffPlasmoid)

#endif
