/***************************************************************************
 *   Copyright (C) 2009 by Björn Ruberg <bjoern@ruberg-wegener.de          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/


#ifndef KOPETEEXTENDER_H_
#define KOPETEEXTENDER_H_

#include "plasma/popupapplet.h"
#include "plasma/extender.h"
#include "plasma/extenderitem.h"
#include "contactslist.h"
#include "kopete_interface.h"
#include "contact.h"

class Contact;

class KopeteExtender: public Plasma::PopupApplet {
Q_OBJECT
public:
	KopeteExtender(QObject *parent, const QVariantList &args);
	virtual ~KopeteExtender();
	void init();
	void initExtenderItem(Plasma::ExtenderItem *item);
	QGraphicsWidget* graphicsWidget();
	QMap<QString,Contact*> updateContacts();
	void updateList(const QString &);
	void openChat(Contact *contact);

protected Q_SLOTS:
	void updateContact(const QString &);


	//void sizeChanged();
private:
	ContactsList *m_contactslist;
	QMap<QString,Contact*> m_contacts;
	org::kde::Kopete* m_interface;
};

#endif /* KOPETEEXTENDER_H_ */


