#include "chatdialog.h"
#include <plasma/widgets/iconwidget.h>
#include "contact.h"
#include <KWindowSystem>
#include <QGraphicsGridLayout>
#include <plasma/widgets/textedit.h>
#include <plasma/widgets/pushbutton.h>
#include <plasma/containment.h>
#include <plasma/corona.h>
#include "KopeteExtender.h"

ChatDialog::ChatDialog(KopeteExtender *applet, Contact *contact) : Plasma::Dialog(0){

    m_contact = contact;

    KWindowSystem::setState(winId(), NET::Sticky); /*NET::SkipTaskbar | NET::SkipPager */
    m_widget = new QGraphicsWidget( applet );
    m_corona = qobject_cast<Plasma::Corona*>(m_widget->scene());
    m_widget->setMinimumSize(100, 100);

    m_layout = new QGraphicsGridLayout( m_widget );
    m_textedit = new Plasma::TextEdit( m_widget );
    m_textedit->setPreferredHeight(30);
    m_layout->addItem(m_textedit, 1, 0);

    m_reply = new Plasma::PushButton( m_widget );
    m_reply->setText( i18n("Send") );
    m_layout->addItem(m_reply, 1, 1);

    m_corona->addOffscreenWidget(m_widget);
    setGraphicsWidget(m_widget);

    move( applet->popupPosition (size()) );
    setWindowTitle( contact->getDisplayName() );
}

ChatDialog::~ChatDialog(){
    delete m_corona;
    m_layout->removeAt(1);
    m_layout->removeAt(0);

    delete m_textedit;
    delete m_reply;
}
