/*****************************************************************************
 *   Copyright (C) 2008 by Ben Cooksley <ben@eclipse.endoftheinternet.org>   *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .          *
 ****************************************************************************/

#include "quizsplash.h"

#include <QLabel>

QuizSplash::QuizSplash(QGraphicsWidget *parent) : Plasma::GroupBox(parent)
{ // Create layouting
    layout = new QGraphicsLinearLayout(Qt::Vertical);
    layout->addItem(&header);
    header.nativeWidget()->setAlignment(Qt::AlignCenter);
    header.nativeWidget()->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
    layout->addItem(&resultsHeader);
    resultsHeader.nativeWidget()->setAlignment(Qt::AlignCenter);
    resultsHeader.nativeWidget()->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
    layout->addItem(&results);
    layout->setAlignment(&results, Qt::AlignCenter);
    results.nativeWidget()->setAlignment(Qt::AlignJustify);
    layout->addItem(&startQuiz);
    setLayout(layout);
    // Apply static text
    resultsHeader.setText(i18n("Top 5 scores"));
}

#include "quizsplash.moc"
