/***************************************************************************
 *   Copyright (C) 2007 by Thomas Moenicke                                 *
 *   thomas.moenicke@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef MELTDOWN_H
#define MELTDOWN_H

#include <QImage>
#include <QPaintDevice>
#include <QLabel>
#include <QPixmap>
#include <QPaintEvent>
#include <QPainter>
#include <QX11Info>
#include <QWidget>
#include <QGraphicsItem>
#include <QColor>

#include <plasma/applet.h>
#include <plasma/dataengine.h>
#include "ui_meltdownConfig.h"

class KDialog;

namespace Plasma
{
  class Svg;
}

class MeltDown : public Plasma::Applet
{
  Q_OBJECT

 public:
    MeltDown(QObject* parent, const QVariantList &args);
    ~MeltDown();

    void constraintsUpdated();
    void paintInterface(QPainter *painter, const QStyleOptionGraphicsItem *option, const QRect &contentsRect );
    QRectF boundingRect() const;

  public slots:
    //void configureDialog();
    void dataUpdated(const QString &source, const Plasma::DataEngine::Data &data);

  protected:
    void createConfigurationInterface(KConfigDialog *parent);
 
  private slots:
    void newSource( const QString &source );

  private:
    Plasma::Svg* m_theme;
    Plasma::DataEngine *engine;
    QRectF m_bounds;
    int m_xPixelSize;
    int m_yPixelSize;
    int m_scale;

    KDialog *m_dialog;
    Ui::meltDownConfig ui;

    //QFontMetrics m_fmFrom;
    //QFontMetrics m_fmSubject;

    QFont m_fontFrom;
    QFont m_fontSubject;

    QMap<int,QString> m_fromList;
    QMap<int,QString> m_subjectList;
};

K_EXPORT_PLASMA_APPLET(meltdown, MeltDown)

#endif
