#ifndef PLASMA_SYSTEMCOMMAND_H
#define PLASMA_SYSTEMCOMMAND_H

#include <QProcess>
#include <Plasma/Applet>

class QGraphicsProxyWidget;
class QTextEdit;
class KLineEdit;

class SystemCommand : public Plasma::Applet
{
    Q_OBJECT
    public:
        SystemCommand(QObject* parent, const QVariantList& args);
        ~SystemCommand();

        void paintInterface(QPainter* painter,
                             const QStyleOptionGraphicsItem* option,
                             const QRect& contentsRect);
        void init();

    private slots:
        void stdout();
        void stderr();
        void run();
        void processStateChanged(QProcess::ProcessState state);

    private:
        KLineEdit* m_lineEdit;
        QTextEdit* m_textEdit;

        QGraphicsProxyWidget* m_lineEditProxy;
        QGraphicsProxyWidget* m_textEditProxy;
        QGraphicsProxyWidget* m_form;

        QProcess m_shell;
};

K_EXPORT_PLASMA_APPLET(systemcommand, SystemCommand)

#endif // PLASMA_SYSTEMCOMMAND_H
