/***************************************************************************
*   Copyright (C) 2007 by Riccardo Iaconelli <riccardo@kde.org>           *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
***************************************************************************/

#ifndef CLOCKNUMBER_H
#define CLOCKNUMBER_H

#include <QtCore/QChar>
#include <QtCore/QPropertyAnimation>
#include <KDebug>

class QVariant;
class QObject;
class QByteArray;

class Number
{
    public:
        Number(QChar value);
        ~Number();
        void operator--();
        void operator++();
        void operator=(QChar value);
        bool operator==(char value);
        operator char();

    private:
        class Private;
        Private * const d;
};

class NumberAnimation : public QPropertyAnimation
{
    public:
        NumberAnimation ( QObject * target, const QByteArray & propertyName, QObject * parent = 0 )
         : QPropertyAnimation ( target, propertyName, parent)
         {};
    protected:
        virtual QVariant interpolated(const QVariant & from, const QVariant & to, qreal progress); // animate qstring and bool.
        virtual void updateCurrentValue ( const QVariant & value )
        {
            kDebug() << value.toBool();
            QPropertyAnimation::updateCurrentValue ( value );
        }

};

#endif

