/*
 *   Copyright (C) 2009 Jesper Thomschütz <jesperht@yahoo.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef WEBAPP_H
#define WEBAPP_H

#include <Plasma/Applet>
#include <Plasma/ToolButton>
#include <Plasma/WebView>
#include <KConfigDialog>

#include <QSvgRenderer>
#include <QObject>

#include "page.h"
#include "ui_config.h"

class Webapp : public Plasma::Applet
{
Q_OBJECT

public:
    Webapp(QObject *parent, const QVariantList &args);
    ~Webapp();
    void init();
    void paintInterface(QPainter *painter, const QStyleOptionGraphicsItem *option, const QRect &rect);
    void constraintsEvent(Plasma::Constraints constraints);

public slots:
    void createConfigurationInterface(KConfigDialog *dialog);
    void viewPressed();
    void favoritePressed();
    void setBackground(QString path);

private slots:
    void loadStarted();
    void loadFinished();

private:
    QString validUrl(QString url);

    Plasma::ToolButton *m_button;
    QSvgRenderer *m_background;
    Plasma::WebView *m_webview;
    Page *m_page;
    Plasma::Applet::BackgroundHint m_backgroundHint;
    Ui::config ui;
};

K_EXPORT_PLASMA_APPLET(webapp, Webapp)
#endif // WEBAPP_H
