/*  
    Copyright 2007 Robert Knight <robertknight@gmail.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef WINDOWSAPPLET_H
#define WINDOWSAPPLET_H

// Plasma
#include <plasma/applet.h>
#include <Plasma/IconWidget>

class WindowsLauncherApplet : public Plasma::Applet
{
        Q_OBJECT
    public:
        /**
        * Constructor.
        *
        * \param parent The parent QObject.
        * \param args The optional list of arguments.
        */
        WindowsLauncherApplet(QObject *parent, const QVariantList &args);

        /**
        * Destructor.
        */
        virtual ~WindowsLauncherApplet();

        /**
         * This method is called once the applet is loaded and added to a Corona.
         **/
        void init();

        /**
         * Called when any of the geometry constraints have been updated.
         *
         * @param constraints the type of constraints that were updated
         */
        void constraintsEvent(Plasma::Constraints constraints);

private Q_SLOTS:
        void toggleMenu(bool pressed);

private:
        Plasma::IconWidget *icon;
};

K_EXPORT_PLASMA_APPLET(windowslauncher, WindowsLauncherApplet)

#endif
