/*
    Copyright (C) 2010 Kevin Krammer <kevin.krammer@gmx.at>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef AKONADIAGENTSSERVICE_H
#define AKONADIAGENTSSERVICE_H

#include <plasma/service.h>

namespace Akonadi {
  class AgentInstance;
}

class AkonadiAgentsService : public Plasma::Service
{
  Q_OBJECT

  public:
    explicit AkonadiAgentsService( QObject *parent = 0 );
    AkonadiAgentsService( QObject *parent, QVariantList &args );
    AkonadiAgentsService( const Akonadi::AgentInstance &agent, QObject *parent = 0 );

    ~AkonadiAgentsService();

  protected:
    Plasma::ServiceJob *createJob( const QString &operation, QMap<QString, QVariant> &parameters );

  private:
    class Private;
    Private *const d;
};

#endif

// kate: space-indent on; indent-width 2; replace-tabs on;
