/*
 *   Copyright 2009 Jan Gerrit Marker <jangerrit@weiler-marker.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2 or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
#ifndef BROWSERBOOKMARKS_H
#define BROWSERBOOKMARKS_H
 
#include <plasma/dataengine.h>
#include <QtCore/QObject>

class QSqlDatabase;
class KBookmarkManager;

class BrowserBookmarksEngine : public Plasma::DataEngine
{
    Q_OBJECT
 
    public:
        BrowserBookmarksEngine(QObject* parent, const QVariantList& args);
 
    protected:
        bool sourceRequestEvent(const QString& name);
        bool updateSourceEvent(const QString& source);

    private:
        QString m_firefoxDbFilePath;
        QString m_firefoxDbCopyPath;
        QSqlDatabase m_firefoxDb;
        KBookmarkManager *m_bookmarkManager;
};
 
#endif // BROWSERBOOKMARKS_H