/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "contact.h"

Contact::Contact(const QString &id) :
	QSharedData(), m_id(id)
{
}

Contact::~Contact()
{
}

QString Contact::id() const
{
	return m_id;
}

QString Contact::photo()
{
	return QString();
}

QString Contact::onlineStatus()
{
	return QString();
}

QString Contact::onlineStatusMessage()
{
	return QString();
}

QString Contact::instantMessagingId()
{
    return QString();
}

QString Contact::email()
{
	return QString();
}

bool Contact::hasLocation()
{
	return false;
}

QPointF Contact::location()
{
	return QPointF();
}

QStringList Contact::unreadInstantMessages()
{
    return QStringList();
}

QDateTime Contact::birthday()
{
    return QDateTime();    
}
