/*
 *   Copyright (C) 2009 Ivan Cukic <ivan.cukic@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef GMAILENGINE_P_H
#define GMAILENGINE_P_H

#include "gmailengine.h"
#include <KIO/Job>

class GmailJob: public Plasma::ServiceJob {
    Q_OBJECT
public:
    GmailJob(const QString & operation, const QMap < QString, QVariant > & parameters, QObject * parent);

    void start();
};

class GmailService: public Plasma::Service {
public:
    GmailService();
    ~GmailService();

    Plasma::ServiceJob * createJob(const QString & operation,
            QMap < QString, QVariant > & parameters);
};

class GmailEngine::Private: public QObject {
    Q_OBJECT
public:
    Private(GmailEngine * parent);

public Q_SLOTS:
    void recv(KIO::Job * job, const QByteArray & data);
    void result(KJob * job);

    void loadMetadata();
    void loadData();

public:
    KJob * job;
    QByteArray xml;
    GmailEngine * const q;
};

#endif
