/*
 * Copyright (C) 2008 Laura Dragan <aprilush@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef NEPOMUKTAGS_ENGINE_H_
#define NEPOMUKTAGS_ENGINE_H_

#include <Plasma/DataEngine>
#include <QMap>
#include <QVariant>
#include <QString>

class NepomukTagsEngine: public Plasma::DataEngine
{
    Q_OBJECT

public:
    NepomukTagsEngine(QObject* parent, const QVariantList& args);
    ~NepomukTagsEngine();

protected:
    void init();
    // the source name will be "all" whatever is given here
    bool sourceRequestEvent(const QString& name);

protected    slots:
    bool updateSourceEvent(const QString& source);

private slots:
    void repositoryChanged();

private:
    QMap<QString, QVariant> m_tags;
    int m_min;
    int m_max;
};

#endif /* NEPOMUKTAGS_ENGINE_H_ */
