/***************************************************************************
 *   Copyright (C) 2008 by Gerhard Gappmeier <gappy1502@gmx.net>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef STOCKSENGINE_H
#define STOCKSENGINE_H

#include <plasma/dataengine.h>

#include <QHttp>

class KJob;

class StocksEngine : public Plasma::DataEngine
{
    Q_OBJECT

public:
    StocksEngine(QObject* parent, const QVariantList& args);
    ~StocksEngine();

    void setPath(QString sPath);
    void setRegEx(QString sRegEx);
    
protected:
    // overloaded Plasma::DataEngine methods
    virtual bool sourceRequestEvent(const QString &name);
    virtual bool updateSourceEvent(const QString &source);

private slots:
    void jobDone(KJob *job);

private:
    void parseCSVLine(const QString &sSource, const QString &sLine);
    
private:
    QString m_sPath;
    QString m_sRegEx;
};


#endif // STOCKSENGINE_H

