/*
 * Copyright (C) 2009 Sacha Schutz ( istdasklar@free.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef ABSTRACT_TRANSLATOR_H_
#define ABSTRACT_TRANSLATOR_H_
#include <QHttp>
#include <KIcon>
#include <KUrl>
#include <QObject>
class AbstractTranslator : public QObject
{
Q_OBJECT

public:
QString name(){return m_name;}
KIcon icon(){return m_icon;}



protected:
  AbstractTranslator(QObject * parent=0);
 
virtual ~AbstractTranslator(){};
void setIcon(KIcon icon){m_icon = icon;}
void setName(QString name){m_name =name;}


public slots:
virtual void setTranslate(QString source, QString from="fr", QString to="es")=0;

signals:
void translated(QString result);





private:
KIcon m_icon;
QString m_name;

};







#endif