/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef GLOBALMENU_H
#define GLOBALMENU_H

#include "XBarInterface.h"

#include <QDomElement>
#include <QMap>
#include <QMenu>
#include <QSignalMapper>
#include <QObject>
#include <QWidget>

#include <KMenu>

#include <Plasma/Applet>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

class GlobalMenu : public QWidget
{
    Q_OBJECT
public:
    explicit GlobalMenu(QWidget *parent = 0);
    virtual ~GlobalMenu();

public Q_SLOTS:
    bool processXEvent(XEvent *ev);
    static bool x11EventFilter(void *message);

    void activate();
    void deactivate();
    void hover(qlonglong key, int idx, int x, int y);
    void popDown(qlonglong key);
    void popup(qlonglong key, int idx, int x, int y);
    void raise(qlonglong key);

private Q_SLOTS:
    void activeWindowChanged(WId);
    void windowChanged(WId);
    void windowAdded(WId);
    void windowRemoved(WId);
    void updateContextMap(WId);
    void buildChildMenu(KMenu *menu, const QDomElement &elem, const QString &prefix = QString());
    void triggered(const QString &id);
//    bool x11EventFilter(void *message);
    void bindGlobalShortcut(const QString &xml);

private:
    QMap<WId, QString> mContextMap;
    QMap<WId, QString> mEventMap;
    Atom mCtxAtom;
    Atom mEvtAtom;

    KMenu *mMenu;
    QSignalMapper *mMapper;

    OrgKdeXBarInterface *mXBarIfce;
};

#endif //GLOBALMENU_H
