# - Find libkonitification-1
# Find the libkonitification-1
#
# This module defines
#  LIBQNOTIFICATIONITEM-1_FOUND - whether the libkonitification-1 library was found
#  QNOTIFICATIONITEM_LIBRARIES - the libkonitification-1 library
#  QNOTIFICATIONITEM_INCLUDE_DIR - the include path of the libkonitification-1 library
#

if (QNOTIFICATIONITEM_INCLUDE_DIR AND QNOTIFICATIONITEM_LIBRARIES)

  # Already in cache
  set (LIBQNOTIFICATIONITEM-1_FOUND TRUE)

else (QNOTIFICATIONITEM_INCLUDE_DIR AND QNOTIFICATIONITEM_LIBRARIES)

  find_library (QNOTIFICATIONITEM_LIBRARIES
    NAMES
    qnotificationitem-1
    PATHS
    ${LIB_INSTALL_DIR}
    ${KDE4_LIB_DIR}
  )

  find_path (QNOTIFICATIONITEM_INCLUDE_DIR
    NAMES
    qnotificationitem.h
    PATH_SUFFIXES
    qnotificationitem-1
    PATHS
    ${INCLUDE_INSTALL_DIR}
    ${KDE4_INCLUDE_DIR}
  )

  include(FindPackageHandleStandardArgs)
  find_package_handle_standard_args(LibQNotificationItem-1 DEFAULT_MSG QNOTIFICATIONITEM_LIBRARIES QNOTIFICATIONITEM_INCLUDE_DIR)

endif (QNOTIFICATIONITEM_INCLUDE_DIR AND QNOTIFICATIONITEM_LIBRARIES)

mark_as_advanced(QNOTIFICATIONITEM_INCLUDE_DIR QNOTIFICATIONITEM_LIBRARIES)
