/*
 *   Copyright 2010 Ryan Rix <ry@n.rix.si>
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef ACTIVITIES_RUNNER_H
#define ACTIVITIES_RUNNER_H

#include <plasma/abstractrunner.h>
#include <KIcon>
#include <QDBusInterface>

#include <kactivitycontroller.h>
#include <kactivityconsumer.h>
#include <kactivityinfo.h>

class ActivitiesRunner : public Plasma::AbstractRunner 
{
    Q_OBJECT
public:
    // Basic Create/Destroy
    ActivitiesRunner( QObject *parent, const QVariantList& args );
    ~ActivitiesRunner();

    void match(Plasma::RunnerContext &context);
    void run(const Plasma::RunnerContext &context, const Plasma::QueryMatch &match);

public Q_SLOTS:
    void checkAvailability(const QString &name, const QString &oldOwner, const QString &newOwner);
    void addActivity( QString id );
    void removeActivity( QString id );
    void updateActivityName(QString id);
    
private:
    QHash<QString,KActivityInfo*> m_activities;
    QHash<QString,QString> m_activityNames;
    
    bool m_enabled;
    
    KActivityController* m_controller;
    KActivityConsumer* m_consumer;
    KActivityInfo* m_info;
};

#endif
