/*
 *   Copyright (C) 2008 Park "segfault" Joon-Kyu <mastermind@planetmono.org>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef PYTHONRUNNER_H
#define PYTHONRUNNER_H

#include <QList>
#include <KGenericFactory>

#include <plasma/abstractrunner.h>

#include <Python.h>

class PythonRunner : public Plasma::AbstractRunner
{
    Q_OBJECT

    public:
        PythonRunner(QObject* parent, const QVariantList &args);
        ~PythonRunner();

        void match(Plasma::RunnerContext &context);
	
    private:
	PyObject *globals_;
	QList<QString> mlist_;
};

K_EXPORT_PLASMA_RUNNER(pythonrunner, PythonRunner)

#endif
