/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KORATBUTTON_H
#define KORATBUTTON_H

#include "koratbar_export.h"
#include "koratitem.h"
#include "koratdefines.h"

#include <QGraphicsWidget>
#include <QObject>

namespace Korat
{
class ButtonPrivate;
class KORATBAR_EXPORT Button : public Item
{
    Q_OBJECT
public:
    enum StyleMode {
        StylePlain,
        StyleDropDown,
        StyleSplitDropDown
    };

    Button(QAction *action, StyleMode styleMode = StylePlain, QGraphicsItem *parent=0);
    Button(QGraphicsWidget *widget, QAction *action, StyleMode styleMode = StylePlain, QGraphicsItem *parent=0);

    StyleMode styleMode(StyleMode styleMode) const;
    void setStyleMode(StyleMode styleMode);

    virtual QList<WeightList> availableWidths();
    virtual qreal getWidth(const WeightList &);
    virtual void adjustWidth(const WeightList &);

    virtual void paint(QPainter *painter,
                       const QStyleOptionGraphicsItem *option,
                       QWidget *widget = 0);
private:
    Q_PRIVATE_SLOT(d, void clicked())
    ButtonPrivate *d;
};
} // namespace Korat

#endif // KORATBUTTON_H
