/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KORATITEM_H
#define KORATITEM_H

#include "koratbar_export.h"

#include "koratdefines.h"

//#include <QGraphicsLayoutItem>
#include <QGraphicsItem>
#include <QGraphicsWidget>
#include <QList>
#include <QMap>

namespace Korat
{
class KORATBAR_EXPORT Item : public QGraphicsWidget
{
    Q_OBJECT
public:

    Item(QGraphicsItem *parent=0);
    virtual ~Item();

    virtual bool isContainer();

    virtual QList<WeightList> availableWidths();
    virtual qreal getWidth(const WeightList &);
    virtual void adjustWidth(const WeightList &);

Q_SIGNALS:
    void sizeChanged();
    
};
} // namespace Korat

#endif // KORATITEM_H
