#ifndef WIDGET_H
#define WIDGET_H

#include <QGLWidget>
#include <QImage>
#include <QPointF>

#include "composition.h"
#include "texture.h"
#include "mesh.h"
#include "nodes/phononinputnode.h"

class QMouseEvent;
namespace Phonon
{
    class MediaObject;
} // namespace Phonon

namespace Quasar
{
    class DisplayNode;
} // namespace Quasar

class Widget : public QGLWidget
{
    Q_OBJECT
public:
    Widget(const QString &imgFile);
    ~Widget();

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void keyPressEvent(QKeyEvent *e);

private:
    Phonon::MediaObject *m_media;
    QPointF m_point;
    Quasar::Composition m_compo;
    Quasar::PhononInputNode *m_input;
    Quasar::Node *m_displayNode;
    Quasar::Node *m_saturationNode;
};

#endif
