#include "widget.h"

#include "node.h"

#include <QMouseEvent>
#include <QVariant>

#include <qdebug.h>

using namespace Quasar;

Widget::Widget(QWidget *parent)
    : QGLWidget(parent),
      m_compo(0)
{
}

void Widget::initializeGL()
{
    glClearColor(0.3, 0.3, 0.3, 1);

}

void Widget::paintGL()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    if (!m_compoInited) {
        m_compo->prepare();
        m_compoInited = true;
    }

    m_compo->execute();
    glFlush();
}

void Widget::resizeGL(int width, int height)
{
    glViewport(0, 0, width, height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0, width, 0, height, -999999, 999999);
    glMatrixMode(GL_MODELVIEW);
}

Quasar::Composition * Widget::composition() const
{
    return m_compo;
}

void Widget::setComposition(Quasar::Composition *compo)
{
    m_compo = compo;
    m_compoInited = false;
}
