#ifndef QUASAR_SHADERNODE_H
#define QUASAR_SHADERNODE_H

#include "renderernode.h"

#include "texture.h"
#include "shader_types.h"

class QTransform;

namespace Quasar
{
    class ShaderNodePrivate;

    class ShaderNode : public RendererNode
    {
        Q_OBJECT
        Q_DECLARE_PRIVATE(ShaderNode)
    public:
        ShaderNode(const QString &name);

    protected:
        bool loadShaders(const QString &vs, const QString &fs);
        GLuint vertexShaderId() const;
        GLuint fragmentShaderId() const;
        GLuint programId() const;

    protected:
        bool setShaderUniform(const char *name, int val);
        bool setShaderUniform(const char *name, float val);
        bool setShaderUniform(const char *name, const vec2 &val);
        bool setShaderUniform(const char *name, const vec3 &val);
        bool setShaderUniform(const char *name, const vec4 &val);

        bool setShaderUniform(const char *name, const QVector<float> &vals);
        bool setShaderUniform(const char *name, const QVector<vec2> &vals);
        bool setShaderUniform(const char *name, const QVector<vec3> &vals);
        bool setShaderUniform(const char *name, const QVector<vec4> &vals);
        bool setShaderMatrixUniform(const char *name,
                                    const QTransform &matrix);

        int uniformLocation(const char *name) const;

    protected:
        virtual void programChanged(GLuint prog);

    protected:
        ShaderNode(const QString &name, ShaderNodePrivate &dd);
    };
}

#endif
