#version 120
uniform sampler2D yuvTex;
uniform float oneOverFrameWidth;

void main()
{
    vec4 coord = gl_TexCoord[0].xyxx;

    // Cb sample is at offset 0 if step == 0 and at offset -1 if step == 1
    coord.z -= step(1.0, mod(coord.x, 2.0));

    // Cr sample is always right of the Cb sample
    coord.w = coord.z + 1.0;

    // normalize s coordinate back to 0..1
    coord.xzw *= oneOverFrameWidth;

    vec3 yuv;
    yuv.r = texture2D(yuvTex, coord.xy).r;
    yuv.g = texture2D(yuvTex, coord.zy).a;
    yuv.b = texture2D(yuvTex, coord.wy).a;

    yuv -= vec3(0.0625, 0.5, 0.5);
    gl_FragColor = vec4(mat3x3(
            1.1643829345703125,  1.1643829345703125, 1.1643829345703125,
            0.0               , -0.2132415771484375, 2.112396240234375,
            1.7927398681640625, -0.5329132080078125, 0.0
            ) * yuv, 1.0);
}
